
/*
	mp-wakeup.c -- $B7ZNL%W%m%;%9$r5/$3$9=gHV$rJQ$($k!#(B
	$Header: /net/home/cvs/teacher/kono/os/ex/thread/src/old/mp-wakeup.c,v 1.1.1.1 2007/12/18 03:39:44 kono Exp $
	Start: 1995/02/27 16:42:19
*/

#include <mp/mp.h>

void process_A();
void process_B();
void process_C();

mp_user_main()
{
   mp_t mp_A, mp_B, mp_C ;

/* $BBT$A>uBV!J(BM_BLOCKED$B!K$G%W%m%;%9$r#38D:n$k!#(B*/
	printf("creating process_A() ...\n");
	mp_A = mp_create( process_A,16000,M_BLOCKED,0,1,2 );
	printf("done.\n");
	printf("creating process_B() ...\n");
	mp_B = mp_create( process_B,16000,M_BLOCKED,1,3,5 );
	printf("done.\n");
	printf("creating process_C() ...\n");
	mp_C = mp_create( process_C,16000,M_BLOCKED,2,3,5 );
	printf("done.\n");

	ready_print(); /* $B#C#P#U;q8;$NBT$A9TNs$NI=<((B */
/* $B$3$N;~E@$G$O!"BT$A9TNs$O6u$K$J$C$F$$$k$3$H$r3N$+$a$J$5$$!#(B*/

/* $B:n$C$?%W%m%;%9$r5U$K!#(B*/
	mp_wakeup( mp_C );
	mp_wakeup( mp_B );
	mp_wakeup( mp_A );

	printf("mp_wakeup C, B, A. \n");
	ready_print(); /* $B#C#P#U;q8;$NBT$A9TNs$NI=<((B */
/* $B$3$N;~E@$G$O!"BT$A9TNs$O!"$I$&$J$C$F$$$k$+!#(B*/
	
	printf("mp_user_main() exit.\n");
}

void process_A( a1,a2,a3 )
    int a1,a2,a3 ;
{
	printf("process_A( %d,%d,%d ) created.\n", a1,a2,a3 );
	ready_print(); /* $B#C#P#U;q8;$NBT$A9TNs$NI=<((B */
	printf("process_A() exit.\n");
}

void process_B( a1,a2,a3 )
    int a1,a2,a3 ;
{
	printf("process_B( %d,%d,%d ) created.\n", a1,a2,a3 );
	ready_print(); /* $B#C#P#U;q8;$NBT$A9TNs$NI=<((B */
	printf("process_B() exit.\n");
}

void process_C( a1,a2,a3 )
    int a1,a2,a3 ;
{
	printf("process_C( %d,%d,%d ) created.\n", a1,a2,a3 );
	ready_print(); /* $B#C#P#U;q8;$NBT$A9TNs$NI=<((B */
	printf("process_C() exit.\n");
}
